refactored the git checkout code

Signed-off-by: Jeremy Mordkoff <Jeremy.Mordkoff@riftio.com>
diff --git a/jenkins/common/all_funcs b/jenkins/common/all_funcs
index 10b7650..a847108 100644
--- a/jenkins/common/all_funcs
+++ b/jenkins/common/all_funcs
@@ -22,9 +22,7 @@
 	export OSM_JENKINS=$(realpath $(dirname ${BASH_SOURCE[0]} ))
 fi
 
-. ${OSM_JENKINS}/common/logging
-INFO "logging sourced"
-. ${OSM_JENKINS}/common/config
-INFO "config sourced"
-. ${OSM_JENKINS}/common/container
-INFO "container sourced"
+for file in logging config container git_functions; do
+	. ${OSM_JENKINS}/common/$file
+	INFO "$file sourced"
+done
diff --git a/jenkins/common/git_functions b/jenkins/common/git_functions
new file mode 100644
index 0000000..7856623
--- /dev/null
+++ b/jenkins/common/git_functions
@@ -0,0 +1,40 @@
+#!/bin/bash
+
+
+GIT() {
+
+	CMD git "$@"
+}
+
+
+OSM_git_checkout() {
+
+    # Updates all the branches in the local repo (clones if it does not exist)
+    if [ -d $OSM_MDG ]; then
+        INFO "reusing existing workspace"
+        cd $OSM_MDG
+        GIT pull --all
+        #git checkout master  #to make sure that we are in the right branch before pulling the code
+        #git pull
+    else
+        INFO "cloning MDG $OSM_MDG from $OSM_GIT_URL/$OSM_MDG"
+        GIT clone $OSM_GIT_URL/$OSM_MDG
+        cd $OSM_MDG
+        for remote in `git branch -r`; do GIT branch --track ${remote#origin/} $remote; done
+    fi
+    
+    if [ $# -gt 0 ]; then
+        if [ "$1" = "checkout" ]; then
+            INFO "Code to compile: '$2'"
+            GIT checkout $2
+        else
+            INFO "Code to compile: gerrit refspec '$1', commit-id: '$2'"
+            GIT fetch origin $1 || FATAL "git fetch origin '$1' didn't work"
+            GIT checkout -f $2 || FATAL "git checkout -f '$2' didn't work"
+        fi
+    else
+        INFO "Code to compile: master"
+        GIT checkout master
+    fi
+
+}
diff --git a/jenkins/common/logging b/jenkins/common/logging
index 3eb4a0d..a95b563 100644
--- a/jenkins/common/logging
+++ b/jenkins/common/logging
@@ -35,13 +35,13 @@
 
 
 FATAL() { 
-	echo "### $(date) ${FUNCNAME[1]}: FATAL error: $*" >&2
+	echo -e "\n### $(date) ${FUNCNAME[1]}: FATAL error: $*" >&2
 	print_stack
 	exit 1
 }
 	
 WARNING() { 
-	echo "### $(date) ${FUNCNAME[1]}: WARNING error: $*" >&2
+	echo -e "\n### $(date) ${FUNCNAME[1]}: WARNING error: $*" >&2
 }
 
 INFO() { 
@@ -51,3 +51,11 @@
 DEBUG() { 
 	echo "#   $(date) ${FUNCNAME[1]}: $*" >&2
 }
+
+CMD() {
+	echo "# executing '$*' ..."
+	"$@"
+	rc=$?
+	echo "# .... '$*' done RC was $rc"
+	return $rc
+}